import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

// Note: This file is based on Flutter's source code, and is collected by AoiHosizora (GitHub: @Aoi-hosizora).
//
// These constants keep the same as the following package:
// - material package: https://github.com/flutter/flutter/tree/2.10.5/packages/flutter/lib/src/material
// - cupertino package: https://github.com/flutter/flutter/tree/2.10.5/packages/flutter/lib/src/cupertino

/// Defined in src/material/app_bar.dart, used by [AppBar].
const double kAppBarLeadingWidth = kToolbarHeight;

/// Defined in src/material/app_bar.dart, used by [AppBar].
const double kAppBarDefaultElevation = 4.0;

/// Defined in src/material/app_bar.dart, used by [AppBar].
const Color kAppBarDefaultShadowColor = Color(0xFF000000);

/// Defined in src/material/banner.dart, used by [MaterialBanner].
const Duration kMaterialBannerTransitionDuration = Duration(milliseconds: 250);

/// Defined in src/material/bottom_app_bar.dart, used by [BottomAppBar].
const double kBottomAppBarDefaultElevation = 8.0;

/// Defined in src/material/bottom_sheet.dart, used by [BottomSheet].
const Duration kBottomSheetEnterDuration = Duration(milliseconds: 250);

/// Defined in src/material/bottom_sheet.dart, used by [BottomSheet].
const Duration kBottomSheetExitDuration = Duration(milliseconds: 200);

/// Defined in src/material/card.dart, used by [Card].
const double kCardDefaultElevation = 1.0;

/// Defined in src/material/dialog.dart, used by [Dialog].
const Duration kMaterialDialogTransitionDuration = Duration(milliseconds: 150);

/// Defined in src/material/dialog.dart, used by [Dialog].
const double kDialogDefaultElevation = 24.0;

/// Defined in src/material/dialog.dart, used by [Dialog].
const EdgeInsets kDialogDefaultInsetPadding = EdgeInsets.symmetric(horizontal: 40.0, vertical: 24.0);

/// Defined in src/material/dialog.dart, used by [AlertDialog].
const EdgeInsets kAlertDialogDefaultTitlePadding = EdgeInsets.fromLTRB(24.0, 24.0, 24.0, 20.0);

/// Defined in src/material/dialog.dart, used by [AlertDialog].
const EdgeInsets kAlertDialogDefaultContentPadding = EdgeInsets.fromLTRB(24.0, 20.0, 24.0, 24.0);

/// Defined in src/material/dialog.dart, used by [AlertDialog].
const EdgeInsets kAlertDialogDefaultButtonPadding = EdgeInsets.symmetric(horizontal: 8.0);

/// Defined in src/material/dialog.dart, used by [SimpleDialog].
const EdgeInsets kSimpleDialogDefaultTitlePadding = EdgeInsets.fromLTRB(24.0, 24.0, 24.0, 0.0);

/// Defined in src/material/dialog.dart, used by [SimpleDialog].
const EdgeInsets kSimpleDialogDefaultContentPadding = EdgeInsets.fromLTRB(0.0, 12.0, 0.0, 16.0);

/// Defined in src/material/dialog.dart, used by [SimpleDialog].
const EdgeInsets kSimpleDialogDefaultOptionPadding = EdgeInsets.symmetric(vertical: 8.0, horizontal: 24.0);

/// Defined in src/material/divider.dart, used by [Divider].
const double kDividerDefaultHeight = 16.0;

/// Defined in src/material/drawer.dart, used by [Drawer].
const double kDrawerWidth = 304.0;

/// Defined in src/material/drawer.dart, used by [Drawer].
const double kDrawerEdgeDragWidth = 20.0;

/// Defined in src/material/drawer.dart, used by [Drawer].
const Duration kDrawerBaseSettleDuration = Duration(milliseconds: 246);

/// Defined in src/material/drawer_header.dart, used by [DrawerHeader].
const double kDrawerHeaderHeight = 160.0 + 1.0;

/// Defined in src/material/drawer_header.dart, used by [DrawerHeader].
const EdgeInsets kDrawerHeaderPadding = EdgeInsets.fromLTRB(16.0, 16.0, 16.0, 8.0);

/// Defined in src/material/dropdown.dart, used by [DropdownButton].
const Duration kDropdownMenuDuration = Duration(milliseconds: 300);

/// Defined in src/material/dropdown.dart, used by [DropdownButton].
const double kDropdownMenuItemHeight = kMinInteractiveDimension;

/// Defined in src/material/expansion_panel.dart, used by [ExpansionPanel].
const double kExpansionPanelHeaderCollapsedHeight = kMinInteractiveDimension;

/// Defined in src/material/expansion_panel.dart, used by [ExpansionPanel].
const Duration kExpansionPanelExpandDuration = kThemeAnimationDuration;

/*

/// Defined in src/material/ink_highlight.dart, used by [InkHighlight].
const Duration kDefaultHighlightFadeDuration = Duration(milliseconds: 200);

/// Defined in src/material/ink_ripple.dart, used by [InkRipple].
const Duration kInkRippleUnconfirmedRippleDuration = Duration(seconds: 1);

/// Defined in src/material/ink_ripple.dart, used by [InkRipple].
const Duration kInkRippleFadeInDuration = Duration(milliseconds: 75);

/// Defined in src/material/ink_ripple.dart, used by [InkRipple].
const Duration kInkRippleRadiusDuration = Duration(milliseconds: 225);

/// Defined in src/material/ink_ripple.dart, used by [InkRipple].
const Duration kInkRippleFadeOutDuration = Duration(milliseconds: 375);

/// Defined in src/material/ink_ripple.dart, used by [InkRipple].
const Duration kInkRippleCancelDuration = Duration(milliseconds: 75);

/// Defined in src/material/ink_ripple.dart, used by [InkRipple].
const double kInkRippleFadeOutIntervalStart = 225.0 / 375.0;

/// Defined in src/material/ink_splash.dart, used by [InkSplash].
const Duration kInkSplashUnconfirmedSplashDuration = Duration(seconds: 1);

/// Defined in src/material/ink_splash.dart, used by [InkSplash].
const Duration kInkSplashSplashFadeDuration = Duration(milliseconds: 200);

/// Defined in src/material/ink_splash.dart, used by [InkSplash].
const double kInkSplashSplashInitialSize = 0.0;

/// Defined in src/material/ink_splash.dart, used by [InkSplash].
const double kInkSplashSplashConfirmedVelocity = 1.0;

 */

/// Defined in src/material/input_decoration.dart, used by [InputDecoration].
const Duration kInputDecorationTransitionDuration = Duration(milliseconds: 200);

/// Defined in src/material/page.dart, used by [MaterialRouteTransitionMixin].
const Duration kMaterialTransitionDuration = Duration(milliseconds: 300);

/// Defined in src/cupertino/route.dart, used by [CupertinoRouteTransitionMixin].
const Duration kCupertinoTransitionDuration = Duration(milliseconds: 400);

/// Defined in src/material/popup_menu.dart, used by [PopupMenuButton].
const Duration kPopupMenuDuration = Duration(milliseconds: 300);

/*

/// Defined in src/material/refresh_indicator.dart, used by [RefreshIndicator].
const double kRefreshDragContainerExtentPercentage = 0.25;

/// Defined in src/material/refresh_indicator.dart, used by [RefreshIndicator].
const double kRefreshDragSizeFactorLimit = 1.5;

/// Defined in src/material/refresh_indicator.dart, used by [RefreshIndicator].
const Duration kRefreshIndicatorSnapDuration = Duration(milliseconds: 150);

/// Defined in src/material/refresh_indicator.dart, used by [RefreshIndicator].
const Duration kRefreshIndicatorScaleDuration = Duration(milliseconds: 200);

 */

/// Defined in src/material/srollbar.dart, used by [Scrollbar].
const Duration kScrollbarFadeDuration = Duration(milliseconds: 300);

/// Defined in src/material/srollbar.dart, used by [Scrollbar].
const Duration kScrollbarTimeToFade = Duration(milliseconds: 600);

/// Defined in src/material/snack_bar.dart, used by [SnackBar].
const Duration kSnackBarTransitionDuration = Duration(milliseconds: 250);

/// Defined in src/material/snack_bar.dart, used by [SnackBar].
const Duration kSnackBarDisplayDuration = Duration(milliseconds: 4000);

/// Defined in src/material/switch.dart, used by [Switch].
const double kSwitchTrackHeight = 14.0;

/// Defined in src/material/switch.dart, used by [Switch].
const double kSwitchTrackWidth = 33.0;

/// Defined in src/material/switch.dart, used by [Switch].
const double kSwitchThumbRadius = 10.0;

/// Defined in src/material/switch.dart, used by [Switch].
const double kSwitchWidth = kSwitchTrackWidth - kSwitchTrackHeight + kMinInteractiveDimension - 8.0;

/// Defined in src/material/switch.dart, used by [Switch].
const double kSwitchHeight = kMinInteractiveDimension;

/// Defined in src/material/switch.dart, used by [Switch].
const double kSwitchHeightCollapsed = kMinInteractiveDimension - 8.0;

/// Defined in src/material/tabs.dart, used by [TabBar].
const double kTabHeight = 46.0;

/// Defined in src/material/tabs.dart, used by [TabBar].
const double kTabDefaultIndicatorWeight = 2.0;

/// Defined in src/material/tabs.dart, used by [TabBar].
const double kTextAndIconTabHeight = 72.0;

/// Defined in src/material/text_selection.dart, used by [TextSelection].
const double kTextSelectionHandleSize = 22.0;

/// Defined in src/material/text_selection.dart, used by [TextSelection].
const double kTextSelectionToolbarContentDistanceBelow = kTextSelectionHandleSize - 2.0;

/// Defined in src/material/text_selection.dart, used by [TextSelection].
const double kTextSelectionToolbarContentDistance = 8.0;

/// Defined in src/material/text_selection_toolbar.dart, used by [TextSelectionToolbar].
const double kTextSelectionToolbarScreenPadding = 8.0;

/// Defined in src/material/text_selection_toolbar.dart, used by [TextSelectionToolbar].
const double kTextSelectionToolbarHeight = 44.0;

/// Defined in src/material/tooltip.dart, used by [Tooltip].
const double kTooltipDefaultVerticalOffset = 24.0;

/// Defined in src/material/tooltip.dart, used by [Tooltip].
const Duration kTooltipFadeInDuration = Duration(milliseconds: 150);

/// Defined in src/material/tooltip.dart, used by [Tooltip].
const Duration kTooltipFadeOutDuration = Duration(milliseconds: 75);

/// Defined in src/material/tooltip.dart, used by [Tooltip].
const Duration kTooltipDefaultShowDuration = Duration(milliseconds: 1500);
